routes/web.php
<?php

use App\Http\Controllers\TodoController;
use Illuminate\Support\Facades\Route;
use App\Http\Middleware\LoggerMiddleWare;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::group(array('prefix' => 'admin'), function () {
    Route::resource('todo', TodoController::class)->middleware(["auth", LoggerMiddleware::class]);
    Route::get('category', [App\Http\Controllers\CategoryController::class, 'index'])->name('category.index')->middleware("auth");
});

Auth::routes();

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Models\Todo;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Category extends Model
{
    const DEFAULT_CATEGORIES = ['Work', 'IT', 'Home', 'Shopping', 'Friends', 'Tonight'];

    use HasFactory;

    public function todos(): HasMany
    {
        return $this->hasMany(Todo::class);
    }

    public function tags()
    {
        return $this->belongsToMany(Tag::class);
    }
}

app/Models/Tag.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tag extends Model
{
    const DEFAULT_TAGS = ['fun', 'personal', 'professional', 'highlight'];
    use HasFactory;

    public function categories()
    {
        return $this->belongsToMany(Category::class);
    }
}

app/Models/Todo.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use App\Models\Category;


class Todo extends Model
{
    use HasFactory;
    use SoftDeletes;
    protected $assignable = ['name', 'description'];
    protected $fillable = ['name', 'description', 'user_id', 'category_id'];

    /**
     * Get the category that owns the todo.
     */
    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreCategoryRequest;
use App\Http\Requests\UpdateCategoryRequest;
use App\Models\Category;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $categories = Category::all();
        return view("category.list", compact("categories"));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreCategoryRequest $request)
    {
        //
    }

    /**
     * Display the specified resource.
     */
    public function show(Category $category)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Category $category)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateCategoryRequest $request, Category $category)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Category $category)
    {
        //
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, ValidatesRequests;
}

app/Http/Controllers/TodoController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreTodoRequest;
use App\Http\Requests\UpdateTodoRequest;
use App\Models\{Todo, Category};
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Gate;

class TodoController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $todos = Todo::where("user_id", Auth::id())->get();
        return view("todo.list", compact("todos"));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        $categories = Category::pluck("name", "id");
        return view('todo.create', compact("categories"));
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(StoreTodoRequest $request)
    {
        Todo::create([
            "name" => $request->name,
            "description" => $request->description,
            "category_id" => $request->category_id,
            "user_id" => Auth::id()
        ]);
        return redirect()->route('todo.index')
            ->with('success', 'Todo successfully created.');
    }

    /**
     * Display the specified resource.
     */
    public function show(Todo $todo)
    {
        if (!Gate::allows('show-todo', $todo)) {
            abort(403);
        }
        return view("todo.show", ["todo" => $todo]);
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Todo $todo)
    {
        if (!Gate::allows('update-todo', $todo)) {
            abort(403);
        }
        $categories = Category::pluck("name", "id");
        return view("todo.edit", compact("todo", "categories"));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateTodoRequest $request, Todo $todo)
    {
        if (!Gate::allows('update-todo', $todo)) {
            abort(403);
        }
        Todo::find($todo->id)->update([
            "name" => $request->input('name'),
            "description" => $request->input('description'),
            "category_id" => $request->category_id
        ]);
        return redirect()->route('todo.index')->with('success', 'Todo successfully updated.');
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Todo $todo)
    {
        $res = $todo->delete();
        if ($res)
            return redirect()->route('todo.index')->with('success', 'Todo successfully deleted.');
        else
            return redirect()->route('todo.index')->with('error', 'Nothing to delete.');
    }
}

resources/views/category/list.blade.php
@extends('layouts.app')

@section('header')
    <h1>My categories</h1>
@endsection


@section('content')
<div class="d-flex justify-content-center">
    <ul class="list-group list-group-flush">
    @foreach ($categories as $categorie)
        <li class="list-group-item list-group-item-action">
        {{ $categorie->name }} 
            @foreach ($categorie->tags as $tag)
                <span class="badge text-bg-secondary">{{$tag->name}}</span>
            @endforeach
        </li>
    @endforeach
    </ul>
</div>
@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>
    <link rel="icon" type="image/png" href="/icon.png" />

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.bunny.net">
    <link href="https://fonts.bunny.net/css?family=Nunito" rel="stylesheet">

    <!-- Scripts -->
    @vite(['resources/sass/app.scss', 'resources/js/app.js'])
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    <img src='/icon.png'/ class='ml-2'  width="30" height="30">{{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav me-auto">
                        @auth
                        @if (Route::has('todo.index'))
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('todo.index') }}">{{ __('Todos') }}</a>
                        </li>
                        @endif
                        @if (Route::has('category.index'))
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('category.index') }}">{{ __('Categories') }}</a>
                        </li>
                        @endif
                        @endauth
                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ms-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>
        <header class='text-center p-4'>
            
            @yield('header')
            @if(session('success'))
                <div class="alert alert-success">
                    {{ session('success') }}
                </div>
            @endif
        
            @if(session('error'))
                <div class="alert alert-danger">
                    {{ session('error') }}
                </div>
            @endif
        </header>
        <main class="py-4">
            @yield('content')
        </main>
        <footer>
            @yield('footer')
        </footer>
    </div>
</body>
</html>

resources/views/todo/create.blade.php
@extends('layouts.app')

@section('header')
    <h1>Create a Todo</h1>
@endsection

@section('content')
<form action="{{ route('todo.store') }}" method="post">
    @include('todo.form')
</form>
@endsection

@section('footer')

@endsection

resources/views/todo/edit.blade.php
@extends('layouts.app')

@section('header')
    <h1>Edit a Todo</h1>
@endsection

@section('content')
<form action="{{ route('todo.update', ['todo' => $todo->id]) }}" method="post">
    @method('PUT')
    @include('todo.form', $todo)
</form>
@endsection

@section('footer')

@endsection

resources/views/todo/form.blade.php
@csrf
<input type="hidden" name="id" value="{{ old('name', empty($todo)?'':$todo->id) }}">
<div class="mb-3">
    <label for="name" class="form-label" required>Title</label>
    <input type="text" class="form-control" id="name" name="name" placeholder="Buy a burger"  value="{{ old('name', empty($todo)?'':$todo->name) }}">
</div>
<div class="mb-3">
    <label for="description" class="form-label">Description</label>
    <textarea class="form-control" id="description" name="description" rows="3">{{ old('description', empty($todo)?'':$todo->description) }}</textarea>
</div>
<div class="mb-3">
    <label for="category_id" class="form-label">Category</label>
    <select name="category_id" id="category_id">
        @foreach ($categories as $id => $category)
        <option value="{{$id}}" 
            @if (old('category_id', empty($todo)?'':$todo->category->id) == $id)
                selected
            @endif
            > 
            {{ $category }} 
        </option>
        @endforeach
    </select>

</div>
<div class="mb-3">
    <button type="submit" class="btn">OK</button>
</div>

resources/views/todo/list.blade.php
@extends('layouts.app')

@section('header')
    <h1>Ma todo list</h1>
@endsection


@section('content')
<div class="d-flex justify-content-center">
    <a href="{{route('todo.create')}}"><button type="button" class="btn btn-success">Ajout d'un todo</button></a>
</div>
<div class="d-flex justify-content-center">
    <ul class="list-group list-group-flush">
    @foreach ($todos as $todo)
        <a href='{{ route('todo.show', ['todo' => $todo->id]) }}' class="list-group-item list-group-item-action">
        {{ $todo->name }}
        </a>
    @endforeach
    </ul>
</div>
@endsection

resources/views/todo/show.blade.php
@extends('layouts.app')

@section('header')
    <h1>View a Todo</h1>
    <a href="{{ route('todo.index') }}" class="btn btn-success">Go back to list</a>
@endsection


@section('content')
    <div class="d-flex justify-content-center">

    
        <div class="card border-0" style="width: 70vw">
            <img src="https://cdn-icons-png.flaticon.com/512/4345/4345800.png" class="card-img-top" style="max-height: 15vh; object-fit:contain">
            <div class="card-body">
            <h4 class="card-title text-center">{{  $todo->name }}  <span class="badge text-bg-secondary">{{$todo->category->name}}</span></h4>
            <p class="card-text">{{  $todo->description }}</p>
            <div class="d-flex flex-column ">
                
                <a href='{{ route('todo.edit', ['todo' => $todo->id]) }}' class="btn btn-primary my-2">
                    <button type="button" class="btn btn-primary">
                        Edit the Todo
                    </button>
                </a>
                <form action="{{route('todo.destroy', ['todo' => $todo->id])}}" method='POST'>
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger w-100">Delete this record</button>
                </form>

            </div>
            
        </div>
    </div>

@endsection

@section('footer')
😗
@endsection